---
import { ChevronRight, ChevronRightCircle, Circle } from 'lucide-astro';

import type { PageTree } from '~/lib/pages';
import { isTree, sortTreeLevel, treeContains } from '~/lib/pages';
import { cn } from '~/lib/utils';

interface Props {
  pageTree: PageTree;
  currentPath?: string;
  showIndex?: boolean;
  class?: string;
}

const { class: className, currentPath, pageTree, showIndex } = Astro.props;

const treeLevel = sortTreeLevel(pageTree);

if (showIndex && pageTree.index) {
  treeLevel.unshift([pageTree.index.title, pageTree.index]);
}

const ICON_SIZE = 16;

const focusClass = 'focus-visible:outline-none focus-visible:ring-primary focus-visible:ring-2';
const focusClassOffset =
  'focus-visible:outline-none focus-visible:ring-primary focus-visible:ring-2 focus-visible:ring-offset-2 ring-offset-background';
const focusClassSecondary =
  'focus-visible:outline-none focus-visible:ring-primary focus-visible:ring-2 focus-visible:ring-offset-2 ring-offset-background';

const hoverClass = 'hover:bg-card hover:text-card-foreground';
---

<ul class={cn('space-y-2 pt-2 sm:space-y-1 sm:pt-1', className)}>
  {
    treeLevel.map(([title, page]) => {
      // If the page is not a tree, or if it is a tree but has no contents (but an index), render a
      // link to the page.
      if (!isTree(page) || (Object.entries(page.contents).length === 0 && page.index)) {
        const thePage = isTree(page) ? page.index! : page;

        // If deploying at root, the page URL for the index page is "" (empty string), but we want
        // it to be "/" so the link works correctly and so we can correctly match it to the current
        // path.
        const url = thePage.url || '/';

        const isCurrent = currentPath !== undefined && currentPath === url;

        return (
          <li>
            <a
              href={url}
              class={cn(
                'flex items-center rounded py-2 pr-4 pl-1 text-sm font-medium underline',
                isCurrent
                  ? cn('bg-primary text-primary-foreground', focusClassOffset)
                  : cn(focusClass, hoverClass),
              )}
            >
              <Circle class="shrink-0 mr-2 ml-1 stroke-[2.5]" size={ICON_SIZE - 4} />
              {title}
            </a>
          </li>
        );
      }

      // Otherwise, render a (sub)tree.
      const tree = page;
      const containsCurrent =
        currentPath !== undefined ? treeContains(tree, currentPath) : undefined;
      const isCurrent =
        currentPath !== undefined ? tree.index && currentPath === tree.index.url : undefined;

      return (
        <li>
          <details
            class={cn(
              'max-sm:open:ring-2 transition-shadow ring-border rounded',
              // HACK: Target ChevronRightCircle svg in summary (and NOT in all children).
              '[&_>_summary_svg]:open:rotate-90',
            )}
            open={containsCurrent}
          >
            <summary
              class={cn('block rounded py-2 pr-4 pl-1 text-sm font-medium', {
                'bg-secondary text-secondary-foreground': containsCurrent,
                'bg-primary text-primary-foreground': isCurrent,
                [focusClassOffset]: isCurrent,
                [focusClass]: !isCurrent,
                [hoverClass]: !isCurrent,
              })}
            >
              {!!tree.index ? (
                <span class="flex items-center underline">
                  <ChevronRightCircle
                    class="shrink-0 ml-[2px] mr-[6px] transition-transform"
                    size={ICON_SIZE}
                  />
                  <a
                    class={cn(isCurrent ? focusClassSecondary : focusClass, 'block rounded')}
                    href={tree.index.url}
                  >
                    {title}
                  </a>
                </span>
              ) : (
                <span class="flex items-center">
                  <ChevronRight
                    class="shrink-0 ml-[2px] mr-[6px] transition-transform"
                    size={ICON_SIZE}
                  />
                  {title}
                </span>
              )}
            </summary>
            <Astro.self
              class="max-sm:mx-2 max-sm:pb-2 rounded-b sm:pl-4"
              pageTree={page}
              currentPath={currentPath}
            />
          </details>
        </li>
      );
    })
  }
</ul>
